﻿/// <reference path="../../../../../Widgets/Wijmo/wijflipcard/jquery.wijmo.wijflipcard.ts"/>
var __extends = this.__extends || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var c1;
(function (c1) {
    var $ = jQuery;

    var c1flipcard = (function (_super) {
        __extends(c1flipcard, _super);
        function c1flipcard() {
            _super.apply(this, arguments);
        }
        c1flipcard.prototype._create = function () {
            var self = this;
            _super.prototype._create.call(this);

            //Default side is front. If currentSide is back, need to flip.
            if (self.options.currentSide === "back") {
                self._silentFlip();
            }
        };

        // flip without animation and events
        c1flipcard.prototype._silentFlip = function () {
            var self = this, o = self.options, savedAnimation = $.extend({}, o.animation);

            // if use o.animation = {} to disable the flip effect, the flipcard will become invisible,
            // so need use set duration = 0.01 to disable the flip effect.
            if (o.animation.type === "flip") {
                //set animation's duration to 0.01 to disable the effect. Cannot set it to 0, 0 means default.
                o.animation.duration = 0.01;
            } else {
                o.animation = {};
            }

            self._isSilentFlip = true;
            self._flipPanels(null);

            o.animation = savedAnimation;
        };

        c1flipcard.prototype._onFlipping = function () {
            if (this._isSilentFlip) {
                return true;
            }
            return _super.prototype._onFlipping.call(this);
        };

        c1flipcard.prototype._onFlipped = function () {
            var self = this;
            if (self._isSilentFlip) {
                // revertedSettings is used for flipping from back to front in IE 7/8/9
                var revertedSettings = self.element.data('flipRevertedSettings');
                if (revertedSettings) {
                    var animation = self.options.animation;
                    revertedSettings.speed = (animation && animation.duration) ? animation.duration : 500;
                }
                self._isSilentFlip = false;
                return;
            }

            _super.prototype._onFlipped.call(this);
            self._changeSide();
        };

        c1flipcard.prototype._changeSide = function () {
            var self = this, o = self.options;
            o.currentSide = o.currentSide === "front" ? "back" : "front";
            self._doPostBackEvent();
        };

        c1flipcard.prototype._doPostBackEvent = function () {
            var o = this.options;
            if (o.autoPostBack && o.postBackEventReference)
                c1common.nonStrictEval(o.postBackEventReference);
        };
        return c1flipcard;
    })(wijmo.flipcard.wijflipcard);
    c1.c1flipcard = c1flipcard;

    c1flipcard.prototype.widgetEventPrefix = "c1flipcard";

    c1flipcard.prototype.options = $.extend(true, {}, $.wijmo.wijflipcard.prototype.options, {
        currentSide: "front",
        autoPostBack: false,
        postBackEventReference: null
    });

    $.wijmo.registerWidget("c1flipcard", c1flipcard.prototype);
})(c1 || (c1 = {}));
